import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {

    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static long n, m;
    static long firstVer, firstHor;


    public static void main(String[] args) throws IOException {
        Random rnd = new Random(0);
//        int t = 100000;
//        for (int test = 0; test < t; test++) {
//            n = rnd.nextInt(100000) + (long) 1e9;
//            m = rnd.nextInt(100000) + (long) 1e9;
//            String testValues = n + " " + m;
//            String ans1 = solve();
//            String ans2 = solveA();
//            if (!ans1.equals(ans2)) {
//                System.out.println(testValues);
//                System.out.println(ans1);
//                System.out.println(ans2);
//                System.out.println("-----------------");
//            }
//        }
        int t = sc.nextInt();
        for (int test = 0; test < t; test++) {
            n = sc.nextLong();
            m = sc.nextLong();
            pw.println(solve());
        }
        pw.close();
    }

    static long sum(long l, long r) {
        return (r * (r + 1)) / 2 - (l * (l - 1)) / 2;
    }

    static long getAnsVer(long ver) {
        long res = abs((m * sum(0, n - 1) * ver + n * sum(0, ver)) - (m * sum(0, n - 1) * (m - ver) + n * sum(ver + 1, m)));
        return res;
    }

    static long getAnsHor(long hor) {
        return abs(sum(0, hor * m) - sum(hor * m + 1, m * n));
    }

    static Pair ver() {
        long l = 0;
        long r = m - 1;
        while (r - l > 2) {
            long m1 = l + (r - l) / 3;
            long m2 = r - (r - l) / 3;
            if (getAnsVer(m1) > getAnsVer(m2))
                l = m1;
            else
                r = m2;
        }
        Pair[] res = {new Pair(getAnsVer(l), l), new Pair(getAnsVer(l + 1), l + 1), new Pair(getAnsVer(l + 2), l + 2)};
        Arrays.sort(res);
        return res[0];
    }

    static Pair hor() {
        long l = 0;
        long r = n - 1;
        while (r - l > 2) {
            long m1 = l + (r - l) / 3;
            long m2 = r - (r - l) / 3;
            if (getAnsHor(m1) > (getAnsHor(m2)))
                l = m1;
            else
                r = m2;
        }
        Pair[] res = {new Pair(getAnsHor(l), l), new Pair(getAnsHor(l + 1), l + 1), new Pair(getAnsHor(l + 2), l + 2)};
        Arrays.sort(res);
        return res[0];
    }

    static String solve() {
        firstVer = n + m * ((n * (n - 1)) / 2);
        firstHor = sum(1, m);
        Pair ver = ver();
        Pair hor = hor();
        if (ver.x > hor.x)
            return ("H " + (hor.y + 1));
        else {
            return ("V " + (ver.y + 1));
        }
    }

    static String solveA() {
        long minAnsVer = 1000000000000000000L, minAnsHor = 1000000000000000000L;
        long indexVer = 0, indexHor = 0;
        for (int i = 0; i < n; i++) {
            long sumup = 0, sumdown = 0;
            for (int j = 0; j < i; j++) {
                for (int k = 0; k < m; k++) {
                    sumup += j * m + k + 1;
                }
            }
            for (int j = i; j < n; j++) {
                for (int k = 0; k < m; k++) {
                    sumdown += j * m + k + 1;
                }
            }
            if (minAnsHor > abs(sumdown - sumup)) {
                minAnsHor = abs(sumdown - sumup);
                indexHor = i + 1;
            }
        }
        for (int i = 0; i < m; i++) {
            long sumleft = 0, sumright = 0;
            for (int j = 0; j < i; j++) {
                for (int k = 0; k < n; k++) {
                    sumleft += k * m + j + 1;
                }
            }
            for (int j = i; j < m; j++) {
                for (int k = 0; k < n; k++) {
                    sumright += k * m + j + 1;
                }
            }
            if (minAnsVer > abs(sumright - sumleft)) {
                minAnsVer = abs(sumright - sumleft);
                indexVer = i + 1;
            }
        }
        if (minAnsHor >= minAnsVer)
            return ("V " + indexVer);
        return ("H " + indexHor);
    }
}

class Triple implements Comparable<Triple> {
    long x, y, index;


    public Triple(Pair xy, long index) {
        this.x = xy.x;
        this.y = xy.y;
        this.index = index;
    }

    public Triple(long x, long y, long index) {
        this.x = x;
        this.y = y;
        this.index = index;
    }

    public int compareTo(Triple o) {
        return Long.compare(x, o.x) * 4 + Long.compare(y, o.y) * 2 + Long.compare(index, o.index);
    }
}

class Pair implements Comparable<Pair> {
    long x, y;

    public Pair(long x, long y) {
        this.x = x;
        this.y = y;
    }

    public int compareTo(Pair o) {
        return Long.compare(x, o.x) * 2 + Long.compare(y, o.y);
    }

    public Pair substract(Pair other, long m) {
        this.x += this.y / (m * m);
        this.y %= m * m;
        other.x += other.y / (m * m);
        other.y %= m * m;

        if (this.x > other.x) return new Pair(this.x - other.x, this.y - other.y);
        if (this.x == other.x) return new Pair(0, abs(this.y - other.y));
        if (other.y < this.y) {
            other.x--;
            other.y += m * m;
            return new Pair(other.x - this.x, other.y - this.y);
        }
        return new Pair(other.x - this.x, other.y - this.y);
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}