import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {

    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static long n, m;
    static long firstVer, firstHor;


    public static void main(String[] args) throws IOException {
        int t = sc.nextInt();
        for (int test = 0; test < t; test++) {
            n = sc.nextLong();
            m = sc.nextLong();
            solve();
        }
        pw.close();
    }

    static long getSum(long l, long r) {
        return (r * (r + 1)) / 2 - (l * (l - 1)) / 2;
    }

    static long getAnsVerSimple(long ver) {
        long res = abs(getSum(1, ver) - getSum(ver + 1, m));
        return res;
    }

    static Pair getAnsHorSimple(long hor) {
        Pair up = new Pair(getSum(0, hor), (hor + 1) * m + getSum(0, m - 1) * (hor + 1));
        Pair down = new Pair(getSum(hor + 1, n - 1), (n - hor) * m + getSum(0, m - 1) * (n - hor));
        Pair res = up.substract(down, m);
        return res;
    }

    static long getAnsVer(long ver) {
        long res = abs(firstVer * (2 * ver - m) + n * (getSum(0, ver - 1) - getSum(ver, m - 1)));
        return res;
    }

    static long getAnsHor(long hor) {
        long res = abs(firstHor * (2 * hor - n) + m * (getSum(0, hor - 1) - getSum(hor, n - 1)));
        return res;
    }

    static Pair ver() {
        long l = 0;
        long r = m - 1;
        while (r - l > 2) {
            long m1 = l + (r - l) / 3;
            long m2 = r - (r - l) / 3;
            if (getAnsVerSimple(m1) > getAnsVerSimple(m2))
                l = m1;
            else
                r = m2;
        }
        Pair[] res = {new Pair(getAnsVer(l), l), new Pair(getAnsVer(l + 1), l + 1), new Pair(getAnsVer(l + 2), l + 2)};
        Arrays.sort(res);
        return res[0];
    }

    static Pair hor() {
        long l = 0;
        long r = n - 1;
        while (r - l > 2) {
            long m1 = l + (r - l) / 3;
            long m2 = r - (r - l) / 3;
            if (getAnsHorSimple(m1).compareTo(getAnsHorSimple(m2)) > 0)
                l = m1;
            else
                r = m2;
        }
        Pair[] res = {new Pair(getAnsHor(l), l), new Pair(getAnsHor(l + 1), l + 1), new Pair(getAnsHor(l + 2), l + 2)};
        Arrays.sort(res);
        return res[0];
    }

    static void solve() {
        firstVer = n + m * ((n * (n - 1)) / 2);
        firstHor = getSum(1, m);
        Pair ver = ver();
        Pair hor = hor();
        if (ver.x > hor.x)
            pw.println("H " + (hor.y + 1));
        else
            pw.println("V " + (ver.y + 1));
    }
}

class Pair implements Comparable<Pair> {
    long x, y;

    public Pair(long x, long y) {
        this.x = x;
        this.y = y;
    }

    public int compareTo(Pair o) {
        return Long.compare(x, o.x) * 2 + Long.compare(y, o.y);
    }

    public Pair substract(Pair other, long m) {
        this.x += this.y / (m * m);
        this.y %= m * m;
        other.x += other.y / (m * m);
        other.y %= m * m;

        if (this.x > other.x) return new Pair(this.x - other.x, this.y - other.y);
        if (this.x == other.x) return new Pair(0, abs(this.y - other.y));
        return new Pair(other.x - this.x, other.y - this.y);
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}