import java.util.*;
import java.io.*;

public class Main {

    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    public static void main(String[] args) throws IOException {
        char[] dna = sc.next().toCharArray();
        int size = dna.length;
        String cnt = "";
        ArrayList<Nuc> nucs = new ArrayList<>();
        for (int i = 0; i < size; i++) {
            if (isDigit(dna[i]))
                cnt += dna[i];
            else {
                nucs.add(new Nuc(dna[i], cnt.length() == 0 ? "1" : cnt));
                cnt = "";
            }
        }
        TreeSet<Action> actions = new TreeSet<>();
        //add
        actions.add(new Action(1, size + 1, 0, other(nucs.get(0).type)));
        int length = 0;
        for (int i = 0; i < nucs.size(); i++) {
            if (nucs.get(i).sizeAdd == 0)
                actions.add(new Action(1, size, length, nucs.get(i).type));
            if (nucs.get(i).cnt > 1) {
                actions.add(new Action(1, size + nucs.get(i).sizeChangeMiddleAdd, length + nucs.get(i).indexMiddleAdd, other(nucs.get(i).type)));
            }
            length += nucs.get(i).cnt;
        }
        //remove
        length = 0;
        for (int i = 0; i < nucs.size(); i++) {
            if (i == 0 || i == nucs.size() - 1) {
                if (nucs.get(i).cnt == 1)
                    actions.add(new Action(2, size - 1, length));
                else if (nucs.get(i).sizeRemove != 0)
                    actions.add(new Action(2, size - 1, length));
            } else {
                if (nucs.get(i).cnt == 1) {
                    if (nucs.get(i - 1).type != nucs.get(i + 1).type)
                        actions.add(new Action(2, size - 1, length));
                    else
                        actions.add(new Action(2, size - ((2 + nucs.get(i - 1).size + nucs.get(i + 1).size) - (1 + (nucs.get(i - 1).cnt + nucs.get(i + 1).cnt + "").length())), length));
                } else if (nucs.get(i).sizeRemove != 0)
                    actions.add(new Action(2, size - 1, length));
            }
            length += nucs.get(i).cnt;
        }
        //change
        length = 0;
        for (int i = 0; i < nucs.size(); i++) {
            if (i == 0) {
                if (nucs.get(i).cnt == 1)
                    actions.add(new Action(3, size, length, other(nucs.get(i + 1).type)));
                else
                    actions.add(new Action(3, size + nucs.get(i).sizeRemove + 1, length, other(nucs.get(i).type)));
                actions.add(new Action(3, size + nucs.get(i + 1).sizeAdd + nucs.get(i +1).sizeRemove, length + nucs.get(i).size - 1, nucs.get(i + 1).type));
            } else if (i == nucs.size() - 1) {
                actions.add(new Action(3, size - 1 + nucs.get(i - 1).sizeAdd + nucs.get(i).sizeRemove, length, nucs.get(i - 1).type));
                if (nucs.get(i).cnt == 1)
                    actions.add(new Action(3, size, length, other(nucs.get(i - 1).type)));
                else
                    actions.add(new Action(3, size + nucs.get(i).sizeRemove + 1, length + nucs.get(i).cnt, other(nucs.get(i).type)));
            } else {
                if (nucs.get(i).cnt == 1) {
                    actions.add(new Action(3, size, length, other(nucs.get(i - 1).type, nucs.get(i + 1).type)));
                    if (nucs.get(i - 1).type != nucs.get(i + 1).type) {
                        actions.add(new Action(3, size - 1 + nucs.get(i - 1).sizeAdd, length, nucs.get(i - 1).type));
                        actions.add(new Action(3, size - 1 + nucs.get(i + 1).sizeAdd, length, nucs.get(i + 1).type));
                    } else
                        actions.add(new Action(3, size - ((1 + nucs.get(i - 1).size + nucs.get(i + 1).size) - (1 + (nucs.get(i - 1).cnt + nucs.get(i + 1).cnt + "").length())), length, nucs.get(i + 1).type));
                } else {
                    actions.add(new Action(3, size + 1 + nucs.get(i - 1).sizeRemove, length, other(nucs.get(i - 1).type)));
                    actions.add(new Action(3, size + nucs.get(i - 1).sizeAdd + nucs.get(i - 1).sizeRemove, length, nucs.get(i - 1).type));
                    actions.add(new Action(3, size + nucs.get(i + 1).sizeAdd + nucs.get(i + 1).sizeRemove, length, nucs.get(i + 1).type));
                }
            }
            if (nucs.get(i).cnt > 2)
                actions.add(new Action(3, size + nucs.get(i).sizeChangeMiddle, length + nucs.get(i).indexMiddle, other(nucs.get(i).type)));
            length += nucs.get(i).cnt;
        }
        pw.println(actions.first().toString());
        pw.print(actions.last().toString());
        pw.close();
    }

    static char other(char a) {
        if (a != 'A') return 'A';
        return 'C';
    }

    static char other(char a, char b) {
        if (a != 'A' && b != 'A') return 'A';
        if (a != 'C' && b != 'C') return 'C';
        return 'G';
    }

    static boolean isDigit(char a) {
        return '0' <= a && a <= '9';
    }
}

class Action implements Comparable<Action> {
    int size;
    int type, index;
    char nuc;

    public Action(int type, int size, int index, char nuc) {
        this.type = type;
        this.size = size;
        this.index = index;
        this.nuc = nuc;
    }

    public Action(int type, int size, int index) {
        this.type = type;
        this.size = size;
        this.index = index;
        this.nuc = 'N';
    }

    public String toString() {
        if (type == 2)
            return type + " " + (index + 1);
        return type + " " + (index + 1) + " " + nuc;
    }

    public int compareTo(Action o) {
        return Integer.compare(this.size, o.size);
    }
}

class Nuc {
    char type;
    int cnt;
    int size;
    int sizeAdd;
    int sizeRemove;
    int sizeChangeMiddle;
    int indexMiddle;
    int sizeChangeMiddleAdd;
    int indexMiddleAdd;

    public int pow10(int n) {
        int res = 1;
        int p10 = 10;
        while (n > 0) {
            if (n % 2 == 1)
                res *= p10;
            p10 *= p10;
            n /= 2;
        }
        return res;
    }

    public Nuc(char type, String cnt) {
        this.type = type;
        this.cnt = Integer.parseInt(cnt);
        this.size = cnt.length();
        this.sizeAdd = (Integer.parseInt(cnt) + 1 + "").length() - cnt.length();
        if (cnt.equals("1")) this.sizeAdd = 1;
        this.sizeRemove = (Integer.parseInt(cnt) - 1 + "").length() - cnt.length();
        if (cnt.equals("1")) this.sizeRemove = -1;
        if (this.cnt == 3) {
            this.indexMiddle = 1;
            this.sizeChangeMiddle = 1;
        }
        if (this.cnt == 4) {
            this.indexMiddle = 1;
            this.sizeChangeMiddle = 2;
        }
        if (this.cnt >= 5) {
            this.indexMiddle = (this.cnt - 1) / 2;
            this.sizeChangeMiddle = (2 + ((this.indexMiddle + "").length()) + ((this.cnt - this.indexMiddle - 1 + "").length())) - this.size;
        }
        if (this.cnt == 2) {
            this.indexMiddleAdd = 1;
            this.sizeChangeMiddleAdd = 1;
        }
        if (this.cnt == 3) {
            this.indexMiddleAdd = 1;
            this.sizeChangeMiddleAdd = 2;
        }
        if (this.cnt >= 4) {
            this.indexMiddleAdd = (this.cnt - 1) / 2 - 1;
            this.sizeChangeMiddleAdd = (2 + ((this.indexMiddle + "").length()) + ((this.cnt - this.indexMiddle - 1 + "").length())) - this.size;
        }
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}