import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    public static void main(String[] args) throws IOException {
        long a = sc.nextLong();
        boolean goodMood = sc.nextInt() == 1;
        if (goodMood)
            solveGoodMood(a);
        else
            solveBadMood(a + "");
//        pw.close();
    }

    static boolean check(String a) {
        TreeMap<Character, Integer> cnts = new TreeMap<>();
        for (int i = 0; i < a.length(); i++)
            cnts.put(a.charAt(i), cnts.getOrDefault(a.charAt(i), 0) + 1);
        if (cnts.size() == 1) return true;
        if (cnts.size() == 2 && min(cnts.firstEntry().getValue(), cnts.lastEntry().getValue()) == 1) return true;
        return false;
    }

    static void solveGoodMood(long a) {
        if (check(a + "")) {
            System.out.print(a);
            return;
        }
        String num = a + "";
        int size = num.length();
        for (int i = num.length() - 1; i > 0; i--) {
            if (check(num)) {
                System.out.print(num);
                return;
            }
            if (num.charAt(i) < num.charAt(i - 1)) {
                num = num.substring(0, i);
                for (int j = i; j < size; j++)
                    num += num.charAt(i - 1);
            } else if (num.charAt(i) > num.charAt(i - 1)) break;
        }
        int i;
        for (i = size - 1; i >= 1 && num.charAt(i - 1) == num.charAt(i); i--) ;
        num = num.substring(0, i - 1) + (char) (num.charAt(i - 1) + 1);
        for (int j = num.length(); j < size; j++)
            num += '0';
        solveGoodMood(Long.parseLong(num));
    }

    static void solveBadMood(String a) {
        String onesLine = "1";
        String firstLine = "";
        String nextLine = "";
        for (int i = 0; i < a.length(); i++) {
            onesLine += "1";
            firstLine += a.charAt(0);
            if (a.charAt(0) != '9')
                nextLine += (char) (a.charAt(0) + 1);
        }
        long first = Long.parseLong(firstLine);
        if (first - Long.parseLong(a) >= 0) System.out.println(firstLine);
        else if (a.charAt(0) != '9') System.out.println(nextLine);
        else System.out.println(onesLine);
    }
}

class Pair {
    char x;
    int y;

    public Pair(char x, int y) {
        this.x = x;
        this.y = y;
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}