import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static int n, m, c;
    static int[][] colors;

    public static void main(String[] args) throws IOException {
        n = sc.nextInt();
        m = sc.nextInt();
        c = sc.nextInt();
        colors = new int[n][m];
        rec(0, 0);
        pw.close();
    }

    static boolean check(int x, int y) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (i == x || j == y) continue;
                int colA = colors[min(x, i)][min(y, j)];
                int colB = colors[min(x, i)][max(y, j)];
                int colC = colors[max(x, i)][min(y, j)];
                int colD = colors[max(x, i)][max(y, j)];
                if (colA == colB && colB == colC && colC == colD) return false;
            }
        }
        return true;
    }

    static void rec(int i, int j) {
        if (j == m) {
            i++;
            j = 0;
        }
        if (i == n) {
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    pw.print(colors[x][y] + " ");
                }
                pw.println();
            }
            pw.close();
            System.exit(0);
        }
        for (int col = 0; col < c; col++) {
            colors[i][j] = col + 1;
            if (!check(i, j)) {
                colors[i][j] = 0;
                continue;
            }
            rec(i, j + 1);
            colors[i][j] = 0;
        }
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}