import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static int n, m, c;
    static int[][] colors;
    static TreeSet<Pair> poses = new TreeSet<>();

    public static void main(String[] args) throws IOException {
        n = sc.nextInt();
        m = sc.nextInt();
        c = sc.nextInt();
        colors = new int[n][m];
        setPoses();
        rec1(0);
        rec2(0);
        pw.close();
    }

    static void setPoses() {
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                poses.add(new Pair(i, j));
    }

    static boolean check(int x, int y) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (i == x || j == y) continue;
                int colA = colors[min(x, i)][min(y, j)];
                int colB = colors[min(x, i)][max(y, j)];
                int colC = colors[max(x, i)][min(y, j)];
                int colD = colors[max(x, i)][max(y, j)];
                if (colA == colB && colB == colC && colC == colD) return false;
            }
        }
        return true;
    }

    static void rec2(int i) {
        if (i == n * m) {
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    pw.print(colors[x][y] + " ");
                }
                pw.println();
            }
            pw.close();
            System.exit(0);
        }
        ArrayList<Pair> canPos = new ArrayList<>(poses);
        for (Pair pos : canPos) {
            for (int col = 1; col <= c; col++) {
                poses.remove(pos);
                colors[pos.x][pos.y] = col;
                if (!check(pos.x, pos.y)) {
                    poses.add(pos);
                    colors[pos.x][pos.y] = 0;
                    continue;
                }
                rec2(i + 1);
                poses.add(pos);
                colors[pos.x][pos.y] = 0;
            }
        }
    }

    static void rec1(int i) {
        if (i == n * m) {
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    pw.print(colors[x][y] + " ");
                }
                pw.println();
            }
            pw.close();
            System.exit(0);
        }
        ArrayList<Pair> canPos = new ArrayList<>(poses);
        for (Pair pos : canPos) {
            for (int col = 1; col <= c; col++) {
                poses.remove(pos);
                colors[pos.x][pos.y] = col;
                if (!check(pos.x, pos.y))
                    continue;
                rec1(i + 1);
                poses.add(pos);
                colors[pos.x][pos.y] = 0;
            }
        }
    }
}

class Pair implements Comparable<Pair> {
    int x, y;

    public Pair(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int compareTo(Pair o) {
        return Integer.compare(x, o.x) * 2 + Integer.compare(y, o.y);
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}