import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static long[] cnts, cntsZero;
    static long[] used;

    static long ans, mod = (long) 1e9 + 7, n;
    static long minus = 0;

    static TreeSet<Triple> possible = new TreeSet<>();

    public static void main(String[] args) throws IOException {
        char[] num1 = sc.next().toCharArray(), num2 = sc.next().toCharArray(), num3 = sc.next().toCharArray();
        n = num1.length;
        cnts = new long[4];
        cntsZero = new long[4];
        used = new long[4];
        long multiplier = 1;
        setPossible();
        for (int i = 0; i < n; i++) {
            int a = num1[i] - '0', b = num2[i] - '0', c = num3[i] - '0';
            int type = 0;
            if (a + b >= 10) type++;
            if ((a + b) % 10 + 1 == c) type += 2;
            cnts[type]++;
            if (a != 0 && b != 0 && c != 0) cntsZero[type]++;
            if (!possible.contains(new Triple(a, b, c))) {
                pw.print(0);
                pw.close();
            }
        }
        if (cnts[0] + cnts[1] + cnts[2] + cnts[3] != n) {
            pw.print(0);
            return;
        }
        for (int type = 0; type < 4; type++)
            multiplier = (multiplier * fact(cnts[type])) % mod;

        rec(0, 0);

        pw.print((ans * multiplier - minus + mod) % mod);
        pw.close();
    }

    static void setPossible() {
        for (int a = 0; a < 10; a++)
            for (int b = 0; b < 10; b++)
                for (int c = 0; c < 10; c++)
                    if (abs((a + b) % 10 - c) <= 1)
                        possible.add(new Triple(a, b, c));
    }

    static void rec(int i, int type) {
        if (i == n) {
            ans++;
            return;
        }
        for (int newType = 0; newType < 4; newType++) {
            long preAns = ans;
            if (newType % 2 != type / 2 || used[newType] >= cnts[newType] || (i == 0 && cntsZero[newType] == 0))
                continue;
            used[newType]++;
            rec(i + 1, newType);
            used[newType]--;
            if (i == 0)
                minus += (ans - preAns) * (cnts[newType] - cntsZero[newType]);
        }
    }

    static long fact(long n) {
        if (n == 0) return 1;
        return (fact(n - 1) * n) % mod;
    }
}

class Triple implements Comparable<Triple> {
    int a, b, c;

    public Triple(int a, int b, int c) {
        this.a = a;
        this.b = b;
        this.c = c;
    }

    public int compareTo(Triple o) {
        return Integer.compare(a, o.a) * 4 + Integer.compare(b, o.b) * 2 + Integer.compare(c, o.c);
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}