import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static long[] cnts;
    static TreeSet<Triple>[] nums = new TreeSet[4];

    static long ans, mod = (long) 1e9 + 7, n;

    static TreeSet<Triple> possible = new TreeSet<>();

    public static void main(String[] args) throws IOException {
        char[] num1 = sc.next().toCharArray(), num2 = sc.next().toCharArray(), num3 = sc.next().toCharArray();
        n = num1.length;
        cnts = new long[4];
        setNums();
        boolean canBe = true;
        for (int i = 0; i < n; i++) {
            int a = num1[i] - '0', b = num2[i] - '0', c = num3[i] - '0';
            int type = 0;
            if (a + b >= 10) type++;
            if ((a + b + 1) % 10 == c) type += 2;
            cnts[type]++;
            Triple num = new Triple(a, b, c, i);
            if (!num.can) canBe = false;

            nums[type].add(num);
        }
        rec(0, 0);
        if (!canBe) ans = 0;
        pw.print(ans % mod);
        pw.close();
    }

    static void setNums() {
        for (int i = 0; i < 4; i++)
            nums[i] = new TreeSet<>();
    }

    static void rec(int i, int type) {
        if (i == n) {
            if (type / 2 == 0)
                ans++;
            return;
        }
        for (int newType = 0; newType < 4; newType++) {
            if (newType % 2 != type / 2)
                continue;
            if(i == 0 && newType / 2 == 1) continue;
            ArrayList<Triple> can = new ArrayList<>(nums[newType]);
            for (Triple num : can) {
                if (num.zero && i == 0) continue;
                nums[newType].remove(num);
                rec(i + 1, newType);
                nums[newType].add(num);
            }
        }
    }

    static long fact(long n) {
        if (n == 0) return 1;
        return (fact(n - 1) * n) % mod;
    }
}

class Triple implements Comparable<Triple> {
    int a, b, c, index;
    boolean zero, can;

    public Triple(int a, int b, int c, int index) {
        this.a = a;
        this.b = b;
        this.c = c;
        this.index = index;
        this.can = (a + b) % 10 == c || (a + b + 1) % 10 == c;
        this.zero = a == 0 || b == 0 || c == 0;
    }

    public int compareTo(Triple o) {
        return Integer.compare(a, o.a) * 8 + Integer.compare(b, o.b) * 4 + Integer.compare(c, o.c) * 2 + Integer.compare(index, o.index);
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}